package l13_lambda;

import java.util.List;
import java.util.function.BiConsumer;

public class BiConsumerFunctionExample {

	private static <T, U> void applyBiConsumer(List<T> t, List<U> u, BiConsumer<T, U> biConsumer) {
		for(int i = 0; i < Math.min(t.size(), u.size()); ++i) {
			biConsumer.accept(t.get(i), u.get(i));
		}
		System.out.println();
	}

	public static void main(String[] args) {

		List<String> stringList1 = List.of("name1", "name2", "name3");
		List<Integer> integerList1 = List.of(1, 2, 3);
		List<Integer> integerList2 = List.of(5, 8, 13);

		applyBiConsumer(integerList1, integerList2,
				(i1, i2) -> System.out.println(i1 + " + " + i2 + " = " + (i1 + i2)));
		applyBiConsumer(integerList1, integerList2,
				(i1, i2) -> System.out.println(i1 + " * " + i2 + " = " + (i1 * i2)));
		applyBiConsumer(stringList1, integerList2,
				(s1, i2) -> System.out.println(s1 + " = " + i2));
	}
}
