package l13_lambda;

import java.util.List;
import java.util.function.Consumer;

public class ConsumerAsParameter {

	static class Employee {
		private final String name;
		private double salary;

		public Employee(String name, double salary) {
			this.name = name;
			this.salary = salary;
		}

		@Override
		public String toString() {
			return String.format("%s: %.2f", name, salary);
		}
	}

	public static void main(String[] args) {
		List<Employee> employees = List.of(
				new Employee("John", 2500.),
				new Employee("Harry", 4300.),
				new Employee("Mark", 3200.)
		);

		//	print all employees
		acceptAllEmployees(employees, System.out::println);
		System.out.println();

		//	increase salary by 10%
		acceptAllEmployees(employees, employee -> employee.salary *= 1.1);

		//	print employees' data again
		acceptAllEmployees(employees, System.out::println);
	}

	private static void acceptAllEmployees(List<Employee> employees, Consumer<Employee> consumer) {
//		for (Employee s : employees) consumer.accept(s);
		employees.forEach(consumer);
	}
}

