package l13_lambda;

/*
	@FunctionalInterface
	public interface Consumer<T>
		void accept(T t)	Performs this operation on the given argument
		default Consumer<T> andThen(Consumer<? super T> after) {
			return (T t) -> { accept(t); after.accept(t); };
	}
*/

import java.util.function.Consumer;

public class ConsumerExample {
	public static void main(String[] args) {

		String string = "Java";

		Consumer<String> toLower = s -> System.out.println(s.toLowerCase());
		Consumer<String> toUpper = s -> System.out.println(s.toUpperCase());
		//	Consumer andThen() returns a composed Consumer that performs, in
		//	sequence, for the current operation followed by the after operation.

		toLower.accept(string);
		toUpper.accept(string);
		System.out.println();

		toLower.andThen(toUpper).accept(string);
		System.out.println();

		Consumer<String> composite = toLower.andThen(toUpper);
		composite.accept(string);
	}
}
