package l13_lambda;

import java.util.Arrays;
import java.util.List;
import java.util.function.Consumer;

public class ConsumerFunctionExample {

	public static void main(String[] args) {
		Consumer<Integer> consumerPrint = i -> System.out.print(" " + i);
		Consumer<Integer> consumerSquareIt = i -> System.out.print("^2 = " + i*i + ",");
		Consumer<Integer> consumerPrintAndSquare = consumerPrint.andThen(consumerSquareIt);

		List<Integer> integerList = Arrays.asList(10, 200, 101, 210, 12);

		printList(integerList, consumerPrint);
		printList(integerList, consumerPrintAndSquare);
	}

	private static void printList(List<Integer> listOfIntegers, Consumer<Integer> consumer) {
//		for(Integer integer : listOfIntegers) {
//			consumer.accept(integer);
//		}
		listOfIntegers.forEach(consumer);
		System.out.println();
	}
}

