package l13_lambda;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.function.BiFunction;
import java.util.function.BinaryOperator;
import java.util.function.Function;
import java.util.function.IntFunction;

public class FunctionTest {

	private static void functionTest() {

//		public interface Function<T, R>
//			R apply(T t)
//		public interface IntFunction<R>
//			R apply(int value); R - the type of the result of the function

		Function<String, Integer> parse = Integer::parseInt;
		System.out.println(parse.apply("23")); // 23
		System.out.println(2 * parse.apply("23")); // 46
		Function<Integer, Integer> squareInt = number -> number * number;
		System.out.println(parse.andThen(squareInt).apply("12")); // 144

		IntFunction<Integer> doubleIt = number -> 2 * number;
		System.out.println(doubleIt.apply(5)); // 10
		IntFunction<String> stringify = number -> "--- " + number + " ---";
		System.out.println(stringify.apply(5));
		System.out.println();
	}

	private static void binaryOperatorTest() {

//	public interface BinaryOperator<T> extends BiFunction<T,T,T>
//		T apply(T, T)

		BinaryOperator<Integer> sumFunction = (a, b) -> a + b;
		System.out.println(sumFunction.andThen(n -> n * n).apply(3, 5)); // (3 + 5)^2
		System.out.println();
	}

	private static void biFunctionTest() {

//	public interface BiFunction<T, U, R>
// 		R apply(T t, U u)

		List<Double> list1 = Arrays.asList(1.0, 2.1, 3.3);
		List<Double> list2 = Arrays.asList(0.1, 0.2, 4.);
		List<Boolean> resultGt = listCombiner(list1, list2, (a, b) -> a > b);
		List<String> resultSum = listCombiner(list1, list2, (a, b) -> String.format("%.2f", a + b));
		System.out.println(resultGt);
		System.out.println(resultSum);
	}

	private static <T, U, R> List<R> listCombiner(List<T> list1, List<U> list2, BiFunction<T, U, R> combiner) {
		int n = Math.min(list1.size(), list2.size());
		List<R> result = new ArrayList<>(n);
		for (int i = 0; i < n; i++) {
			result.add(combiner.apply(list1.get(i), list2.get(i)));
		}
		return result;
	}

	public static void main(String[] args) {
		functionTest();
		binaryOperatorTest();
		biFunctionTest();
	}
}
