package l13_lambda;

/*
	We've got a couple of implementations for the circle interface and two
	different operations with respect to context. Those anonymous class
	implementations itself are passed as argument to another generic method,
	thus achieving a level of generic function.
*/

public class LambdaFunctionArgument {

	@FunctionalInterface // exactly one anonymous function
	interface CircleInterface {
		double apply(double radius);
	}

	private static double circleOperation(CircleInterface circle, double radius) {
		return circle.apply(radius);
	}

	public static void main(String[] args){
		System.out.format("Area: %.4f%n", circleOperation(r -> Math.PI * r * r, 2));
		System.out.format("Circumference: %.4f%n", circleOperation(r -> 2 * Math.PI * r, 4));
	}
}

