package l13_lambda;

public class WorkerInterfaceTest {

	@FunctionalInterface
	interface WorkerInterface {
		void doSomeWork();
	}

	private static void execute(WorkerInterface worker) {
		worker.doSomeWork();
	}

	public static void main(String [] args) {

		//invoke doSomeWork using Anonymous class
		execute(new WorkerInterface() {
			@Override
			public void doSomeWork() {
				System.out.println("Worker invoked using Anonymous class");
			}
		});

		//invoke doSomeWork using Lambda expression
		execute(() -> System.out.println("Worker invoked using Lambda expression"));
		System.out.println();
	}
}

